MAP_FORMRESPONSE_KEY_TO_QUESTION = False

TASK_TYPE_MAPPING = {"R": "Read", "Q": "Query", "F": "Form", "C": "Custom"}

TASK_TO_FORMRESPONSE_MAPPING = {
    "protocol.label": "protocol.label",
    "task_type": "task.type",
    "origin.id": "task.origin",
    "status": "task.status",
    "due_date": "task.due_date",
    "task_id": "task.task_id",
    "assignee": "task.assignee",
}

HIERARCHY_COLS = [
    "parents.group",
    "group",
    "parents.project",
    "project.label",
    "parents.subject",
    "subject.label",
    "parents.session",
    "session.label",
    "session.timestamp",
    "session_url",
    "parents.acquisition",
    "acquisition.label",
    "parents.file",
    "file.name",
]

RESPONSE_COLS_MAPPING = {
    "task.task_id": "Task ID",
    "task.type": "Task Type",
    "protocol.label": "Protocol Name",
    "group": "Group",
    "project.label": "Project Label",
    "subject.label": "Subject Label",
    "session.label": "Session Label",
    "session.timestamp": "Session Timestamp",
    "acquisition.label": "Acquisition Label",
    "file.name": "File Name",
    "task.assignee": "Task Assignee",
    "task.origin": "Task Creator",
    "task.due_date": "Task Due Date",
    "task.status": "Task Status",
    "question": "Question",
    "answer": "Answer",
    "created": "Created",
    "modified": "Modified",
    "revision": "Revision",
    "session_url": "URL",
    "parents.group": "group",
    "parents.project": "project.id",
    "parents.subject": "subject.id",
    "parents.session": "session.id",
    "parents.acquisition": "acquisition.id",
    "parents.file": "file.file_id",
    "_id": "formresponse.id",
    "form_id": "form.id",
    "task_id": "task.id",
}

FILE_COLUMNS = [
    "_id",
    "name",
    "type",
    "file_id",
    "version",
    "mimetype",
    "modality",
    "deid_log_id",
    "deid_log_skip_reason",
    "tags",
    "provider_id",
    "restored_from",
    "restored_by",
    "path",
    "reference",
    "virus_scan",
    "created",
    "modified",
    "replaced",
    "deleted",
    "size",
    "hash",
    "client_hash",
    "info_exists",
    "zip_member_count",
    "gear_info",
    "copy_of",
    "original_copy_of",
    "parent_ref.id",
    "parent_ref.type",
    "parents.group",
    "parents.project",
    "parents.subject",
    "parents.session",
    "parents.acquisition",
    "parents.analysis",
    "origin.type",
    "origin.id",
]


ANNOTATIONS_COLS_MAPPING = {
    "task.task_id": "Task ID",
    "task.type": "Task Type",
    "group": "Group",
    "project.label": "Project Label",
    "subject.label": "Subject Label",
    "session.label": "Session Label",
    "session.timestamp": "Session Timestamp",
    "acquisition.label": "Acquisition Label",
    "file.name": "File Name",  # TODO: Lookup from the file object and version.
    "task.assignee": "Task Assignee",
    "task.origin": "Task Creator",
    "task.due_date": "Task Due Date",
    "task.status": "Task Status",
    # TODO: These columns are not in the export, but are in the API. Revisit with
    #       customer feedback. We may want to rename for NIfTI files.
    # "data.StudyInstanceUID": "StudyInstanceUID",
    # "data.SeriesInstanceUID": "SeriesInstanceUID",
    # "data.SOPInstanceUID": "SOPInstanceUID",
    "data.sliceNumber": "SliceNumber",
    # "data.frameIndex": "FrameIndex",  repeated a few lines below
    "data.location": "Location",
    "_id": "Annotation ID",
    "property": "Property",
    "value": "Value",
    "created": "Created",
    "modified": "Modified",
    "revision": "Revision",
    "data.frameIndex": "frameIndex",
    "data.imagePath": "imagePath",
    "parents.group": "group",
    "parents.project": "project.id",
    "parents.subject": "subject.id",
    "parents.session": "session.id",
    "parents.acquisition": "acquisition.id",
    "file_ref.file_id": "File ID",
    "file_ref.version": "File Version",
    "task_id": "task.id",
}

ANNOTATION_COLS = {
    "data.toolType": "toolType",
    "data.length": "Length",
    "data.shortestDiameter": "ShortestDiameter",
    "data.longestDiameter": "LongestDiameter",
    "data.rAngle": "Angle",
    "data.area": "Area",
    "data.units": "Units",
    "data.meanStdDev.mean": "Mean",
    "data.meanStdDev.stdDev": "StdDev",
    "data.meanStdDev.variance": "Variance",
    "data.cachedStats.area": "Area",
    "data.cachedStats.mean": "Mean",
    "data.cachedStats.stdDev": "StdDev",
    "data.cachedStats.variance": "Variance",
    "data.handles.start.x": "minX",
    "data.handles.start.y": "minY",
    "data.handles.end.x": "maxX",
    "data.handles.end.y": "maxY",
    "data.handles.perpendicularStart.x": "perp_minX",
    "data.handles.perpendicularStart.y": "perp_minY",
    "data.handles.perpendicularEnd.x": "perp_maxX",
    "data.handles.perpendicularEnd.y": "perp_maxY",
    "data.polyBoundingBox.left": "minX",
    "data.polyBoundingBox.top": "minY",
    "data.polyBoundingBox.width": "boxWidth",
    "data.polyBoundingBox.height": "boxHeight",
}

TASK_COLUMNS = [
    "_id",
    "assignee",
    "status",
    "form_id",
    "viewer",
    "viewer_config_id",
    "config_overrides",
    "task_type",
    "batch_number",
    "batch_total_tasks",
    "item_number",
    "task_id",
    "protocol_id",
    "due_date",
    "created",
    "modified",
    "revision",
    "filters",
    "parent.id",
    "parent.type",
    "parent.version",
    "parents.group",
    "parents.project",
    "parents.subject",
    "parents.session",
    "parents.acquisition",
    "parents.file",
    "parents.analysis",
    "info.orientations",
    "info.date",
    "info.readTime",
    "info.readStatus",
    "info.displayProperties.protocolLayoutConfig",
    "info.displayProperties.viewportsData",
    "info.displayProperties.layout.numColumns",
    "info.displayProperties.layout.numRows",
    "info.displayProperties.is2DMPRMode",
    "info.displayProperties.formHeight",
    "info.displayProperties.dataProtocol",
    "info.displayProperties.activeViewportIndex",
    "info.displayProperties.colorMapId",
    "info.displayProperties.channelId",
    "origin.type",
    "origin.id",
    "parent_tag_filter.include",
    "parent_tag_filter.exclude",
    "parent_info.group._id",
    "parent_info.group.label",
    "parent_info.project._id",
    "parent_info.project.label",
    "parent_info.subject._id",
    "parent_info.subject.label",
    "parent_info.session._id",
    "parent_info.session.label",
    "parent_info.acquisition._id",
    "parent_info.acquisition.label",
    "parent_info.analysis",
    "parent_info.file.id.file_id",
    "parent_info.file.id.version",
    "parent_info.file.name",
    "parent_info.file.parent_type",
    "info",
    "protocol.label",
    "project.label",
    "group",
    "subject.label",
    "session.label",
    "acquisition.label",
    "file.name",
    "session_url",
]
